<?php

/**
* @copyright Copyright (C) 2009 Guessous Mehdi Imed
* @license GNU/GPLv2 see http://www.gnu.org/licenses/gpl-2.0.html
**/

 ?><?php

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Add a filter
$thisplugin->add_filter('template_html','joomla_visualinteg_template_html');

//-------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------ all call back functions -----------------------------------------------

//--- callback func used to fix links in javascripts------
function scriptFixCallback($matches) {
    global $joomRel;
    
    //** error: cannot use backreference in a class of characters,
    //the following expression was incorrect:
    //  $value=preg_replace('#\.src\s*=\s*([\'"])([^/:\\1][^:\\1]*)\\1#i','.src=\1'. $joomRel . '\2\1',$matches[2]);
    
    //fix link especially for the template changer
    $value=preg_replace('#\.src\s*=\s*(["\'])((?!/)(?:[^\\\\"\':]|\\\\[^:]|(?!\1)["\'])*)\1#i','.src=\1'. $joomRel . '\2\1',$matches[2]);
    //--- fix for modules that use ajax, especially Who's Online XT
    $value=preg_replace('%=\s*([\'"])(modules/mod_((?!\1)[^:\.]*)\.php)\1%i','=\1'. $joomRel . '\2\1',$value);
    
    $value='<script'. $matches[1] .'>'. $value . '</script>';
    return $value;
}


//----- callback func used to fix embedded styles
function styleFixCallback($matches) {
    global $joomRel;
    $value=preg_replace('#url\s*\(([^/:\)][^:\)]*)\)#i','url('. $joomRel . '\1)', $matches[2]);
    $value='<style'. $matches[1] .'>'. $value . '</style>';
    return $value;
}

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

function joomla_visualinteg_template_html($scriptOutput) {
    global $THEME_DIR, $BRIDGE, $CONFIG;
    global $joomRel, $joomlaOutput, $scriptRel, $script_slash_path;
    
    if (!defined('_JEXEC') || !isset($joomlaOutput)) {
        return($scriptOutput);
    }
    
    $joomRel=$BRIDGE['relative_path_to_config_file'];
    $joomUrl=$BRIDGE['full_forum_url'];
    $scriptUrl=rtrim($CONFIG['site_url'],"/"); //correspond to ecards_more_pic_target in config table, silly
    
    if (preg_match('#<html[^>]*>.*?<head[^>]*>(.*?)</head>.*?<body[^>]*>(.*)</body>.*?</html>#si',$scriptOutput,$matches)) {
        $scriptOutputHead=$matches[1];
        $scriptOutputBody=$matches[2];
        unset($matches[1]);
        unset($matches[2]);
        unset($scriptOutput);
    } else die("Please ensure that the file <i>template.html</i> of your current Coppermine's theme has a valid Html syntax. <br/>
                   Especially check the \"html\", \"head\",  \"body\" tags.");
                   
    $finalOutput= $joomlaOutput; //this is the joomla output retrieved by joomla.inc.php
    
    $joomConf=& JFactory::getConfig();
    
//replace base tag for sef , don't forget the ending slash
    if ($joomConf->getValue('config.sef')) {
        $finalOutput=preg_replace('#<base\s*href\s*=[^>]*>#i','<base href="' . $scriptUrl . '/" />',$finalOutput);
    }
    
//Fix the links in the included page to refer to the Joomla root directory
//all below are attributes, so must begin by a space, removed: link, not a valid attribute
//exclude links , that are "pure" anchors

    $finalOutput=preg_replace('#(<[^>]*\s(?:href|src|action|background))\s*=\s*"([^/:"\#][^:"]*)"#i','\1="'. $joomRel .'\2"',$finalOutput);
    
//Fix param tag for flash only
    $finalOutput=preg_replace('#<param\s+name="movie"\s+value="([^/:"][^:"]*\.swf[\?"])#i','<param name="movie" value="'. $joomRel .'\1',$finalOutput);
    
    { //Fix login module
        //----- now , joomla refuse full url in return parameter of login module
        //----- also relative path doesn't work with sef enabled
        //----- last solution : path that begin with slash
        $returnVal= base64_encode($script_slash_path);
        $finalOutput=preg_replace('#<input\s+[^>]*name="return"\s+value="[A-Za-z0-9+/=]+"[^>]*>#i','<input name="return" value="'  . $returnVal . '" type="hidden" />',$finalOutput);
        
        //----- for community builder, no confusion possible with other parsing because of the B: , so I  do it systematically ----
        // notice: com_comprofiler, check if begin of return val begin by $joomUrl ------------------------------------------------
        // hence the somehow dumb path --------------------------------------------------------------------------------------------
        $returnVal=$joomUrl . '/' . $scriptRel . 'index.php';
        $returnVal= base64_encode($returnVal);
        $finalOutput=preg_replace('#<input\s+[^>]*name="return"\s+value="B:[A-Za-z0-9+/=]+"[^>]*>#i','<input name="return" value="B:'  . $returnVal . '" type="hidden" />',$finalOutput);
    }//end block Fix login module
    
//fix links in javascripts, especially the template changer
    $finalOutput=preg_replace_callback('#<script([^>]*)>(.*?)</script>#si',"scriptFixCallback", $finalOutput);
    
//fix embedded styles
    $finalOutput=preg_replace_callback('#<style([^>]*)>(.*?)</style>#si',"styleFixCallback", $finalOutput);
    
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//remove joomla's title will be overridden by script's one
    $finalOutput=preg_replace('#<title([^>]*)>.*?</title>#si','',$finalOutput);
    
//------------- put any coppermine addition at the end
//if an alternative css exist use it instead of the default one
    if (file_exists($THEME_DIR."style2.css"))
        $scriptOutputHead=preg_replace('#<link([^>]*)href="([^>\"]*)style.css"([^>]*)>#i','<link\1href="\2style2.css"\3>',$scriptOutputHead);
        
    $scriptOutputHead= "\n<!-- +++++++++++++++++++ Script head +++++++++++++++++++ -->\n" . $scriptOutputHead;
    
//Merge coppermine head to joomla's head
    $finalOutput=preg_replace('#</head>#i',$scriptOutputHead . "\n</head>",$finalOutput,1);    //replace first occurrence only
//if there's two, something is wrong

//insert coppermine template
    $finalOutput=str_replace('{COPPERMINE_TEMPLATE_HTML}',$scriptOutputBody,$finalOutput);
    
    return($finalOutput);
}//end function joomla_visualinteg_template_html
